=== debian/changelog ===
kyverno (1.15.0-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.15.0 release
  * Update the static-version-number quilt patch
  * Bump the golang-go version required to build

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sat, 09 Aug 2025 19:49:31 +0200

kyverno (1.13.2-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.13.2 version
  * Update the static-version-number quilt patch
  * Bump the golang-go version required to build

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Tue, 14 Jan 2025 20:54:02 +0200

kyverno (1.12.5-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.12.5 version
  * Update all quilt patchs
  * Bump the Standards-Version
  * Bump the golang-go version required to build
  * Drop the i386 arch

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sat, 17 Aug 2024 19:17:26 +0200

kyverno (1.12.1-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.12.1 version
  * Update all quilt patchs

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Wed, 08 May 2024 12:44:52 +0200

kyverno (1.10.3-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.10.3 version
  * Update the static-version-number quilt patch

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sat, 07 Oct 2023 20:59:33 +0100

kyverno (1.10.2-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.10.2 version
  * Update the static-version-number quilt patch
  * Remove golang-go as package dependancy

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Mon, 07 Aug 2023 20:15:29 +0100

kyverno (1.10.1-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.10.1 version
  * Remove the remove-git-and-use-a-static-version-number patch

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sun, 23 Jul 2023 01:53:27 +0100

kyverno (1.9.3-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.9.3 version
  * Update the quilt patch

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Wed, 24 May 2023 01:28:52 +0100

kyverno (1.9.2-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.9.2 version
  * Update the quilt patch

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Tue, 09 May 2023 01:48:22 +0100

kyverno (1.9.1-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.9.1 version
  * No display the commit ID (quilt patch)
  * Improve the removal of git commit and use the static version number

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sun, 19 Mar 2023 21:36:33 +0100

kyverno (1.8.5-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.8.5 version
  * Improvements of the packaging
  * Update the quilt patch

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Fri, 13 Jan 2023 01:35:39 +0100

kyverno (1.8.2-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.8.2 release
  * Update the quilt patch
  * Update the golang-go version required

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Wed, 23 Nov 2022 16:48:49 +0100

kyverno (1.7.3-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.7.3 release
  * Update the quilt patch

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sun, 25 Sep 2022 21:01:56 +0100

kyverno (1.7.2-1kaisen) kaisen-packages; urgency=medium

  * Import 1.7.2 release
  * Update the quilt patch

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sun, 14 Aug 2022 18:26:47 +0100

kyverno (1.7.1-1kaisen) kaisen-packages; urgency=medium

  * Import 1.7.1 release
  * Update quilt patch

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Fri, 08 Jul 2022 03:09:27 +0100

kyverno (1.7.0-1kaisen) kaisen-packages; urgency=medium

  * Import 1.7.0 release
  * Update quilt patch

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Fri, 03 Jun 2022 20:58:51 +0100

kyverno (1.6.2-1kaisen) kaisen-packages; urgency=medium

  * Import 1.6.2 release

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Fri, 06 May 2022 02:07:22 +0100

kyverno (1.6.1-1kaisen) kaisen-packages; urgency=medium

  * Import 1.6.1 release

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Tue, 29 Feb 2022 23:51:37 +0100

kyverno (1.6.0-1kaisen) kaisen-packages; urgency=medium

  * First packaging for Kaisen Linux

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Mon, 14 Feb 2022 00:33:01 +0100
