=== debian/rules ===
#!/usr/bin/make -f

export GOPATH=$(CURDIR)/_build

%:
	dh $@ --buildsystem=golang --builddirectory=$(CURDIR)/_build

override_dh_auto_clean:
	rm -rf $(CURDIR)/_build/ $(CURDIR)/cmd/cli/kubectl-kyverno/kubectl-kyverno

override_dh_auto_build:
	make build-all

override_dh_auto_test:

override_dh_auto_install:
	$(CURDIR)/cmd/cli/kubectl-kyverno/kubectl-kyverno completion bash > $(CURDIR)/debian/kyverno/usr/share/bash-completion/completions/kyverno
	$(CURDIR)/cmd/cli/kubectl-kyverno/kubectl-kyverno completion zsh > $(CURDIR)/debian/kyverno/usr/share/zsh/vendor-completions/_kyverno
	install -p -m 0755 $(CURDIR)/cmd/cli/kubectl-kyverno/kubectl-kyverno $(CURDIR)/debian/kyverno/usr/bin/kyverno
	install -p -m 0644 $(CURDIR)/debian/kyverno.png $(CURDIR)/debian/kyverno/usr/share/pixmaps/

override_dh_installdocs:
	dh_installdocs --all $(CURDIR)/*.md $(CURDIR)/CODEOWNERS $(CURDIR)/LICENSE
